package com.winhc.repal.cloud;

import com.winhc.common.base.BeanResponse;
import com.winhc.common.model.base.VOPage;
import com.winhc.repal.cloud.dto.WinCoinOrderFormDTO;
import com.winhc.repal.cloud.vo.ResponseVO;
import com.winhc.repal.cloud.vo.WinCoinOrderFormVO;
import com.winhc.repal.config.BeanConfig;
import com.winhc.repal.model.dto.RepalOrderPageDTO;
import feign.codec.Decoder;
import org.springframework.boot.autoconfigure.http.HttpMessageConverters;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.cloud.openfeign.support.SpringDecoder;
import org.springframework.context.annotation.Bean;
import org.springframework.http.MediaType;
import org.springframework.http.converter.json.MappingJackson2HttpMessageConverter;
import org.springframework.web.bind.annotation.*;

import java.util.Collections;
import java.util.List;

/**
 * @author Aaron
 * @date 2022/5/10 14:16
 * @description
 */
@FeignClient(value = "win-coin", configuration = BeanConfig.FeignConvertConfig.class)
//@FeignClient(value = "win-coin",url = "106.14.81.247:5907")
public interface WinCoinService {

    /**
     * 创建订单
     * @param dto
     * @return
     */
    @PostMapping("/winCoins/order")
    BeanResponse<WinCoinOrderFormVO> createOrder(@RequestHeader("userInfo")String userInfo,
                                                 @RequestHeader("appVersion")String appVersion,
                                                 @RequestHeader("appPackage")String appPackage,
                                                 @RequestBody WinCoinOrderFormDTO dto);


    /**
     * 获取
     * @param dto dto
     * @return com.winhc.common.base.BeanResponse<com.winhc.common.model.base.VOPage < com.winhc.repal.cloud.vo.WinCoinOrderFormVO>>
     * @author xda
     * @date 2022/5/20 12:07
     */
    @PostMapping("/winCoins/repal/order")
    ResponseVO<VOPage<WinCoinOrderFormVO>> getRepalOrderPage(@RequestBody RepalOrderPageDTO dto);


    /**
     * 获取订单id
     * @param userBean userBean
     * @param orderId orderId
     * @return com.winhc.common.base.BeanResponse<com.winhc.repal.cloud.vo.WinCoinOrderFormVO>
     * @author xda
     * @date 2022/5/22 09:09
     */
    @GetMapping("/winCoins/order/{orderId}")
    BeanResponse<WinCoinOrderFormVO> getOrderForm(@RequestHeader("userInfo") String userBean, @PathVariable("orderId") String orderId);




}
